;
;   ASSEMBLER INSTRUCTION
;
.386p
cseg segment para use16 public 'code'
simple proc far
assume cs:cseg,es:cseg,ds:cseg

head_flc_f struc
flc_size        dd ?
flc_magic       dw ?
flc_kadrs       dw ?
flc_Width       dw ?
flc_Hight       dw ?
flc_Bits_prim   dw ?
flc_Flags3      dw ?
flc_Speed       dd ?
flc_unused      dd ?
flc_Created     dd ?
flc_Creator     dd ?
flc_Updated     dd ?
flc_Updator     dd ?
flc_AspectX     dw ?
flc_AspectY     dw ?
flc_reserv1     db 38 dup (?)
flc_Offset1     dd ?
flc_Offset2     dd ?
flc_reserv2     db 40 dup (?)
head_flc_f ends

hd_kadr struc
kd_size         dd ?
kd_id           dw ?
kd_frags        dw ?
kd_reserve      db 8 dup (?)
hd_kadr ends

frag_head struc
fr_size         dd ?
fr_type         dw ?
frag_head ends


ERROR   MACRO msg
        local labl
        jnc labl
        lea dx,msg
        mov ah,9
        int 21h
        mov ax,4C01h
        int 21h
        int 20h
labl:
        ENDM

PRINTL  MACRO txt
        mov ah,9
        lea dx,txt
        int 21h
        ENDM

pause   MACRO time
        local loop1
        push ax
        mov ax,time
loop1:
        push ax
        call kadr_prog_pause
        pop ax
        dec ax
        jnz loop1
        pop ax
        ENDM

        org 100h
        LOCALS
begin:
        jmp start
head_frag       dw ?    ;  ࠣ
head_kadr       dw ?    ;  
head_flc        dw ?    ;  FLC
file_handle     dw ?    ;  䠩
file_name       dw ?    ;  䠩
here            dw ?    ; ࠭ ⮩ 
pause_kadrs     dw 3    ; ᫮ ஢

        INCLUDE prog_sw.asm
        INCLUDE w_files.asm
start:
        push cs
        pop ds
        push cs
        pop es

        mov ax,13h
        int 10h                 ; ० ᯫ 13h
        call input_switch
start2:
        push cs
        pop ds
        push cs
        pop es

        mov si,81h
        lea di,eop
        call input_file_name
        ERROR no_name
        mov file_name,di
        add di,cx
        add di,2
        mov here,di
        mov di,file_name
        call open_file
        ERROR error_file
        mov file_handle,bx

        mov dx,here
        mov head_flc,dx
        add dx,128
        mov head_kadr,dx
        add dx,16
        mov head_frag,dx
        add dx,6
        mov here,dx

        mov cx,128
        mov dx,head_flc
        mov bx,file_handle
        call read_file
        ERROR error_read
;        PRINTL head_flc_txt    ; *********
        mov bx,head_flc
        cmp [bx].flc_magic,0AF12h
        jz magic_ok
        stc
        ERROR no_flc_file
magic_ok:
        mov ax,[bx].flc_width
        cmp ax,320
        jz width_ok
        jc width_ok
        stc
        ERROR size_txt
width_ok:
        mov ax,[bx].flc_Hight
        cmp ax,200
        jz higth_ok
        jc higth_ok
        stc
        ERROR size_txt
higth_ok:
read_head_kadr:
        mov dx,head_kadr
        mov cx,16
        mov bx,file_handle
        call read_file
        ERROR error_read
;        PRINTL head_kadr_txt   ; *********
        mov bx,head_kadr
        cmp [bx].kd_id,0F1FAh
        jnz no_kadr_dats
;        PRINTL kadr_data       ; *********
        call kadr_prog
        jmp next_kadr
no_kadr_dats:
        cmp [bx].kd_id,00A1h
        jz skip_kadr
        cmp [bx].kd_id,0F100h
        jz skip_kadr
        stc
        ERROR kadr_id_txt
skip_kadr:
;        PRINTL kadr_skip       ; ********
        mov bx,head_kadr
        mov dx,word ptr [bx].kd_size
        mov cx,word ptr [bx].kd_size+2
        sub dx,16
        sbb cx,0
        mov bx,file_handle
        call shift_file
next_kadr:
        pause pause_kadrs
        mov bx,head_flc
        dec [bx].flc_kadrs
        jz prog_end
        jmp read_head_kadr
prog_end:
        mov bx,file_handle
        call close_file
        jmp start2

program_end:
        mov bx,file_handle
        call close_file
        PRINTL end_file_txt
        mov ax,4C00h
        int 21h
        int 20h
;*************************************************

kadr_prog proc near
        mov bx,head_kadr
        cmp [bx].kd_frags,0
        jnz kadr_prog_cont
        ret
kadr_prog_cont:
        push es
        mov di,0
        mov ax,0A000h
        mov es,ax

kadr_prog_loop:
        mov dx,head_frag
        mov cx,6
        mov bx,file_handle
        push es
        call read_file
        ERROR error_read
        pop es
;        jmp next_frag

        mov bx,head_frag
        cmp [bx].fr_type,4
        jz FLI_COLOR_256
        cmp [bx].fr_type,7
        jz FLI_WORD_LC
        cmp [bx].fr_type,11
        jz FLI_COLOR
        cmp [bx].fr_type,12
        jz FLI_LC
        cmp [bx].fr_type,13
        jz FLI_BLACK
        cmp [bx].fr_type,15
        jz FLI_BRUN
        cmp [bx].fr_type,16
        jz FLI_COPY
        cmp [bx].fr_type,18
        jz FLI_PREVIEW
        stc
        ERROR frag_dats
;*************************************************
FLI_WORD_LC:
        call read_frag
	call fli_word_lc_prog
        jmp next_frag2

;**********************************************
FLI_LC:
        call read_frag
        call fli_lc_prog
        jmp next_frag2
;**************************************************
FLI_BLACK:
        mov ax,0
        mov cx,32000
        rep stosw
        jmp next_frag2
;**************************************************
FLI_BRUN:
        call read_frag
	call fli_brun_prog
        jmp next_frag2

;**************************************************
FLI_COPY:
        call read_screen
        jmp next_frag2

FLI_PREVIEW:
        jmp next_frag
FLI_COLOR:
        call read_frag
        call fli_color_prog
        jmp next_frag2
FLI_COLOR_256:
        call read_frag
        call fli_color_prog
        jmp next_frag2

next_frag:
        mov bx,head_frag
        mov dx,word ptr [bx].fr_size
        mov cx,word ptr [bx].fr_size+2
        sub dx,6
        sbb cx,0
        mov bx,file_handle
        call shift_file
next_frag2:
        mov bx,head_kadr
        dec [bx].kd_frags
        jnz kadr_prog_loop
        pop es
        ret

kadr_prog endp

read_screen proc near
        mov bx,file_handle
        mov cx,64000
        mov dx,0
        push ds
        mov ax,0A000h
        mov ds,ax
        call read_file
        pop ds
        ret
read_screen endp

READ_frag proc near
;        PRINTL read_frag_txt
        mov bx,head_frag
        mov cx,word ptr [bx].fr_size
        mov ax,word ptr [bx].fr_size+2
        cmp ax,0
        jnz too2_long_frag
;        cmp cx,0E000h
;        jnc too_long_frag
        sub cx,6
        mov dx,0
        mov bx,file_handle
        push ds
        mov ax,ds
        add ax,1000h
        mov ds,ax
        call read_file
        pop ds
        ret
too_long_frag:
        stc
        ERROR too_long_txt
too2_long_frag:
        stc
        ERROR too2_long_txt
READ_frag endp

fli_lc_prog proc near
        LOCALS
        push ds
        mov ax,ds
        add ax,1000h
        mov ds,ax
        mov si,0

        lodsw           ; ய᪠ ப
        mov cx,320
        mul cx
        add di,ax
        lodsw           ; 塞 ப
        mov dx,ax
        push di
line_loop:
	lodsb           ; ᫮ ⮢  ப
	or al,al
        jz next_line
        mov bl,al
paket_loop:
        lodsb           ; ᫮ ய᪠ ᥫ
        xor ch,ch
        mov cl,al
        add di,cx
        lodsb           ; ᫮ 塞 ᥫ
        mov cl,al
        test al,80h
        jnz cont_pic    ; ᫨ al<0  騥 ᥫ
        rep movsb
        dec bl
        jnz paket_loop
        jmp next_line
cont_pic:
        neg cl
        lodsb
        rep stosb
        dec bl
        jnz paket_loop
next_line:
        pop di
        add di,320
	push di
        dec dx
        jnz line_loop
	pop di
        pop ds
        ret
fli_lc_prog endp

fli_word_lc_prog proc near
	locals
        push ds
        mov ax,ds
        add ax,1000h
        mov ds,ax
        mov si,0

        lodsw           ; 饥 ᫮ ப
        mov dx,ax

wl_line_loop:
        lodsw           ; content
        cmp ax,0C000h
        jc wl_next_type1
        neg ax          ; ய᪠ ப
wl_loop_1:
        add di,320
        dec ax
        jnz wl_loop_1
;        dec dx
;        jz wl_end_frag
        jmp wl_line_loop

wl_next_type1:
        cmp ax,4000h
        jnc wl_line_loop

        mov bx,ax       ; ᫮ ⮢
        push di
wl_paket_loop:
        lodsb           ; யa ᫮
        mov cl,al
        xor ch,ch
        add di,cx
;        add di,cx
        lodsb           ; 塞 ᫮
        mov cl,al
        test al,80h
        jnz wl_cont_pic
        xor ch,ch
        rep movsw
        dec bx
        jnz wl_paket_loop
        pop di
        add di,320
        dec dx
        jz wl_end_frag
        jmp wl_line_loop

wl_cont_pic:
        neg cl
;        clc
;        ror cx,1
        lodsw
        rep stosw
        dec bx
        jnz wl_paket_loop

        pop di
        add di,320
        jmp wl_next_line

wl_next_type2:
        stosb
        jmp wl_next_line

wl_next_line:
        dec dx
        jnz wl_line_loop
wl_end_frag:
        pop ds
        ret

fli_word_lc_prog endp

fli_brun_prog proc near
        locals
        push ds
        mov ax,ds
        add ax,1000h
        mov ds,ax
        mov si,0

        mov bx,cs:head_flc
        mov dx,cs:[bx].flc_Hight
        push di
br_line_loop:
        lodsb           ; ᫮ ⮢  ப
        or al,al
        jz br_next_line
        mov bl,al
br_paket_loop:
        lodsb		; ᫮ ᥫ
        xor ch,ch
        mov cl,al
        test al,80h
        jz br_cont_pic	; 騨 ᥫ
        neg cl
        rep movsb
        dec bl
        jnz br_paket_loop
        jmp br_next_line
br_cont_pic:
        lodsb
        rep stosb
        dec bl
        jnz br_paket_loop
br_next_line:
        pop di
        add di,320
        push di
        dec dx
        jnz br_line_loop
        pop di
        pop ds
	ret
fli_brun_prog endp

fli_color_prog proc near
        locals
        push ds
        mov ax,ds
        add ax,1000h
        mov ds,ax
        mov si,0
	push es

	lodsw
	mov dx,ax
	mov bx,0
	cmp dx,0
	jz fli_col_end
fli_col_loop:
	lodsw
        add bl,al
        mov cl,ah
        xor ch,ch
        cmp cl,0
        jnz no_fli_cch
        mov cx,100h
no_fli_cch:
	pusha

	push ds
	pop es
	mov dx,si
        call demul_pal
        mov ax,1012h
        int 10h

	popa

	add bx,cx
	add si,cx
	add si,cx
	add si,cx
        inc si
        and si,0FFFEh

	dec dx
	jnz fli_col_loop
fli_col_end:

	pop es
	pop ds
	ret
fli_color_prog endp

demul_pal proc near
;        ret
        LOCAL
        pusha
        mov di,si
loops:
        lodsw
        ror ax,2
        and ax,3F3Fh
        stosw
        lodsb
        ror ax,2
        and ax,3F3Fh
        stosb
        dec cx
        jnz loops
        popa
        ret
demul_pal endp

kadr_prog_pause proc near
	pusha

        mov ah,01
        int 16h
        jnz program_end

	mov dx,3DAh
	in al,dx
	mov cx,0
kp_loops:
;        dec cx
;        jz prog_ret
	mov bl,al
        xor bl,0FFh
	in al,dx
	mov ah,al
        and ah,bl
	test ah,08h
        jz kp_loops
prog_ret:
	popa
	ret
kadr_prog_pause endp
;**********************************
decas:
        push cs                        ;
        pop es                         ;
        lea di,bufer_f                 ;
        call create_file               ;
                                       ;
        push bx                        ;
        mov bx,head_frag               ;
        mov cx,word ptr [bx].fr_size   ;
        pop bx                         ;
        push bx                        ;
        push ds                        ;
        mov ax,ds                      ;
        add ax,1000h                   ;
        mov ds,ax                      ;
        mov dx,0                       ;
        call write_file                ;
        pop ds                         ;
        ERROR xx2                      ;
        pop bx                         ;
        call close_file                ;
        ERROR xx3                      ;
        stc                            ;
        ERROR tx1                      ;
bufer_f: db 'bufer',0,'$'              ;
tx1:    db 'Saved $'                   ;
xx1     db '1$'                        ;
xx2     db '2$'                        ;
xx3     db '3$'                        ;
;*************************************

kadr_speed proc near
        call input_number
        mov ah,0
        cmp ax,0
        jz no_num
        mov pause_kadrs,ax
no_num:
        ret
kadr_speed endp

input_number proc near
                push di
                mov ax,0
                mov dx,0
                push ax

                push si
                mov bx,10
input_num_loop1:
                LODSB
                cmp al,' '
                jz cont_number
                cmp al,','
                jz cont_number
                cmp al,'/'
                jz cont_number
                cmp al,13
                jz cont_number
                cmp al,0
                jz cont_number
                cmp al,'#'
                jz cont_number1
                cmp al,'H'
                jz cont_number1
                cmp al,'h'
                jz cont_number1
                jmp input_num_loop1
cont_number1:   mov bx,16
cont_number:    pop si                  ; bx - ᭮ ᫥ 10/16
cont_number2:   LODSB
                cmp al,'#'
                jz cont_number2
cont_number3:
                mov cx,bx
                lea di,table_num_sym
                REPNZ SCASB
                jnz no_num_sym

                mov ax,bx
                dec ax
                sub ax,cx
                mov cx,ax               ; cx - । 
                pop ax                  ; dx,ax - ⥪饥 ᫮

                push dx

                mul bx
                add ax,cx
                adc dx,0
                pop cx
                push ax
                push dx
                mov ax,cx
                mul bx
                mov dx,ax
                pop ax
                add dx,ax
                pop ax                  ; dx,ax - ᫮
                push ax
                LODSB
                jmp cont_number3

no_num_sym:     cmp al,','
                jz no_num_sym1
                cmp al,' '
                jz no_num_sym1
                cmp al,13
                jz no_num_sym1
                cmp al,0
                jz no_num_sym1
                cmp al,'/'
                jz no_num_sym2
                lodsb
                jmp no_num_sym
no_num_sym2:    dec si
no_num_sym1:
                pop ax
                pop di
                clc
                ret
input_number endp

table_num_sym:  db '0123456789ABCDEF'

read_frag_txt:  db '뢠 ࠣ $'
too_long_txt:   db '誮  ࠣ.',13,10,'$'
too2_long_txt:  db ' ࠣ.',13,10,'$'
end_file_txt:   db 'ଠ쭮 襭.',13,10,'$'
frag_dats:      db ' ࠣ',13,10,'$'
kadr_id_txt:    db '㦥  .',13,10,'$'
size_txt        db 'FLC ଠ ᫨誮 让.',13,10,'$'
no_flc_file:    db '  FLC.',13,10,'$'
no_name:        db ' 㪠 䠩.',13,10,'$'
error_file:     db ' 䠩  ୮ .',13,10,'$'
error_read:     db '  ⠥.',13,10,'$'
head_flc_txt:   db ' FLC ⠭',13,10,'$'
head_kadr_txt:  db '  ⠭ $'
kadr_skip:      db '- skips !',13,10,'$'
kadr_data:      db '- ',13,10,'$'
help:           db '祣  ᪠ !',13,10,'$'

eop:

;
simple endp
cseg ends
end begin
