
;[BEGIN]
;//MODULE: DOS_X
;//CREATE: 19-05-1998	AUTHOR:	Denis Parinov
;//UPDATE: 24-10-1999	DNS	Restore	module
;---------------------------------------------------------------
;Rev	Date	   Name	Description
;---------------------------------------------------------------
;R07	17-12-1999 DNS	BUG FIX	SIGNATURE #55AA	ON SHIFT 510
;R06	21-11-1999 DNS	FN. DISKINF SUPPORT ALL	DISKS
;R05	21-11-1999 DNS	BUG FIX	SIGNATURE #55AA	IN BOOT	SECTOR
;R04	08-11-1999 DNS	KILL OLD FUNCTIONS
;R03	23-11-1998 DNS	(IX+28)	-> (IY+28)
;R02	21-11-1998 DNS	CHANGE "MAKE FAT"
;R01	20-11-1998 DNS	REPAIR FUNCTION	"SAVE"
;---------------------------------------------------------------

RGADR	EQU	#89	;VIDEO CONTROL REGISTER
PAGE0	EQU	#82	;WIN #0000-#3FFF
PAGE1	EQU	#A2	;WIN #4000-#7FFF
PAGE2	EQU	#C2	;WIN #8000-#BFFF
PAGE3	EQU	#E2	;WIN #C000-#FFFF

SYSPAGE	EQU	#FE

;Commands for restart #10
NOPS
	LD	A,1
	SCF 
	RET 

VERSION	LD	DE,VERS*256+MODF
	XOR	A
	LD	H,A
	LD	L,A
	LD	B,A
	LD	C,A
	RET 

CHNDISK	PUSH	AF
	LD	C,1
	RST	#18
	POP	BC
	JP	C,NDISK11
	LD	A,B
	LD	(DRIVE),A
	CALL	RD_BPB
	RET	C
	LD	A,(LDRIVE)
	AND	A
	RET 

NDISK11	CP	2
	SCF 
	RET	Z
	LD	A,20
	SCF 
	RET 

CURRDSK	LD	A,(DRIVE)
	AND	A
	RET 

DISKINF	INC	A
	JR	Z,CURRDS	;R06
	DEC	A		;R06
	CALL	CHNDISK		;R06
	RET	C		;R06
CURRDS	LD	HL,2
	LD	BC,0
FRESP	PUSH	BC
	CALL	R_F_FAT
	POP	BC
	CP	10
	JR	Z,FRESP2
	XOR	A
	CP	E
	JR	NZ,SKIC
	CP	D
	JR	NZ,SKIC
	INC	BC
SKIC	INC	HL
	JP	FRESP

FRESP2	LD	D,B
	LD	E,C
	LD	HL,(MAX_CLU)
	DEC	HL
	LD	BC,(B_P_S)
	LD	A,(S_P_C)
	AND	A
	RET 

LDRIVE	DEFB	#02
TDRIVE	DEFB	#00
TCLUST	DEFW	#0000
TCOUNT	DEFW	#0000

;R04SIZE2CL LD	    DE,(B_P_C)
;R04	    XOR	    A
;R04	    SCF
;R04S2C01   RR	    D
;R04	    RR	    E
;R04	    JR	    C,S2C02
;R04	    RR	    H
;R04	    RR	    L
;R04	    RR	    B
;R04	    RR	    C
;R04	    JP	    NC,S2C01
;R04	    LD	    A,1
;R04	    JP	    S2C01
;R04S2C02   OR	    A
;R04	    RET	    Z
;R04	    INC	    BC
;R04	    RET

;R04L_SEC_X DEFW    0
;R04H_SEC_X DEFW    0

TESTDSK	LD	A,(DRIVE)
	LD	C,3
	RST	#18
	OR	A
	RET	Z
RD_BPB	LD	C,PAGE3
	IN	B,(C)
	PUSH	BC
	IN	A,(PAGE0)
	OUT	(PAGE3),A
	LD	DE,BOOT+#C000
	LD	A,(DRIVE)
	LD	C,4
	RST	#18
	POP	BC
	OUT	(C),B
	JP	C,RDERR1
	PUSH	IY
	LD	DE,#AA55	;R05
	LD	HL,(BOOT+510)	;R07
	AND	A		;R05
	SBC	HL,DE		;R05
	JP	NZ,ERR_BPB	;R05
	LD	IY,BOOT
	LD	A,(IY+#15)
	CP	#F0
	JP	C,ERR_BPB
	LD	HL,0	      ;	calc. first sector FAT
	LD	E,(IY+#0E)    ;Reserve sec
	LD	D,(IY+#0F)
	ADD	HL,DE
;	LD	E,(IY+#1C)    ;Hidden sec
;	LD	D,(IY+#1D)
;	ADD	HL,DE
	LD	(FAT_FRM),HL  ;	first sector FAT
	LD	(FAT1_XX),HL  ;	first sector FAT #1
	LD	(FAT2_XX),HL

	LD	E,(IY+#16)    ;	sectors	in FAT
	LD	D,(IY+#17)
	LD	A,(FAT_NUM)   ;	amount FATs
	CP	1
	JR	Z,C_DATA1
	DEC	A
	ADD	HL,DE
	LD	(FAT2_XX),HL
C_DATA1	ADD	HL,DE
	DEC	A
	JR	NZ,C_DATA1
	LD	(DIR_FRM),HL  ;	first sector DIR

	LD	C,(IY+#0B)    ;	Size sectors
	LD	B,(IY+#0C)
	RL	C
	RL	B
	RL	C
	RL	B
	RL	C
	RL	B
	LD	C,B
	LD	B,0	      ;	BC - File handels in sectors
	LD	A,C
	LD	(F_P_S),A
	LD	E,(IY+#11)    ;	Number file handel
	LD	D,(IY+#12)
	EX	DE,HL
	DEC	HL
	XOR	A
NEXTAD2
	INC	A
	JP	Z,ERR_BPB
	SBC	HL,BC
	JR	NC,NEXTAD2
	EX	DE,HL
	LD	C,A	      ;	A - sectors in DIR
	LD	B,0
	LD	(DIR_S_S),A
	ADD	HL,BC	      ;	Start DATA area
	LD	(DAT_FRM),HL
	LD	C,(IY+#0B)    ;	Size sector
	LD	B,(IY+#0C)
	LD	HL,0
	LD	A,(S_P_C)
NEXTAD3
	ADD	HL,BC	      ;	calc. cluster size
	DEC	A
	JR	NZ,NEXTAD3
	LD	(CLU_LEN),HL
	EX	DE,HL
	LD	HL,3FFFH
	XOR	A
NEXTAD4
	INC	A
	JP	Z,ERR_BPB
	SBC	HL,DE
	JR	NC,NEXTAD4
	LD	(C_P_B),A      ; A - Clusters per bank (16k)

	LD	HL,ID_FAT
	LD	DE,FATMSG
	LD	B,3
R_BPBL1
	LD	A,(DE)
	CP	(HL)
	JP	NZ,IBMDOS_
	INC	HL
	INC	DE
	DJNZ	R_BPBL1
FID	LD	A,(HL)
	INC	HL
	CP	#20
	JR	Z,FID
	CP	"1"
	JP	NZ,ERR_BPB
	LD	A,(HL)
	CP	"6"	       ; FAT16
	LD	HL,#FFFF
	JR	Z,BPB_FAT
	CP	"2"	       ; FAT12
	JP	NZ,ERR_BPB
	LD	HL,#0FFF
BPB_FAT
	LD	(FAT_TYP),A
	LD	(ENDCLUS),HL
	LD	HL,0
	LD	C,(IY+#18)    ;	Sector per track
	LD	B,(IY+#19)
	LD	A,(HEADS)
BPB_L1:			      ;	calc. sector per cylinder
	ADD	HL,BC
	DEC	A
	JR	NZ,BPB_L1
	LD	(S_X_H),HL

	LD	DE,(DAT_FRM)
;	LD	E,(IY+#1C)    ;Hidden sec
;	LD	D,(IY+#1D)
;	AND	A
;	SBC	HL,DE
;	EX	DE,HL
	LD	L,(IY+#13)
	LD	H,(IY+#14)
	LD	A,H
	OR	L
	JP	NZ,HDDSMAL
	LD	L,(IY+#20)
	LD	H,(IY+#21)
	LD	C,(IY+#22)
	LD	B,(IY+#23)
	AND	A
	SBC	HL,DE
	JP	NC,HDDBIG
	DEC	BC
	JP	HDDBIG
HDDSMAL	AND	A
	SBC	HL,DE
	LD	BC,0
HDDBIG	LD	A,(S_P_C)
	SCF 
S4C01	RRA 
	JR	C,S4C02
	RR	B
	RR	C
	RR	H
	RR	L
	JP	S4C01
S4C02	INC	HL
	LD	(MAX_CLU),HL
	POP	IY
;	LD	DE,FAT
;	LD	HL,0
;	LD	IX,(FAT_FRM)
;	LD	B,3
;	LD	A,(DRIVE)
;	LD	C,5
;	RST	#18
;	JP	C,RDERR1
	LD	HL,0
	LD	(FATCASH),HL
	LD	A,FATPAGE
	CALL	BANK
	PUSH	AF
	XOR	A
	CALL	RE_FAT
	POP	AF
	OUT	(PAGE3),A
	CALL	R_CLUST
	XOR	A
	RET 

IBMDOS_	LD	A,(IY+#15)
	CP	#F0
	JP	C,ERR_BPB
	CP	#F8
	LD	A,"6"
	LD	HL,#FFFF
	JP	Z,BPB_FAT
	LD	A,"2"
	LD	HL,#0FFF
	JP	BPB_FAT

ERR_BPB	POP	IY
	LD	A,13
	SCF 
	RET 

RDERR1	LD	A,20
	SCF 
	RET 

FATMSG	DEFB	"FAT"

READ_PG	DEFB	#00

BLOCK	DEFB	#00

DIR_CLU	DEFW	#0000

DRIVE	DEFB	#01
FAT_FRM
FAT1_XX	DEFW	#0000	; MSD_FAT_SEC first sector FAT
FAT2_XX	DEFW	#0000
DIR_FRH	DEFW	#0000	; MSD_CAT_SEC first sector DIR
DIR_FRM
DIR_FRL	DEFW	#0000	; MSD_CAT_SEC first sector DIR
F_P_S	DEFB	#00
DIR_S_S	DEFB	#00	; DIR_SEC_SIZE
DAT_FRM	DEFW	#0000	; MSD_DAT_SEC
CLU_LEN
B_P_C	DEFW	#0000	; CLUSTER_LEN
C_P_B	DEFB	#00	; A - Clusters per bank	(16k)
FAT_TYP	DEFB	#00	; TYPE FAT (#32	- 12bit, #36 - 16bit)
S_X_H	DEFW	#0000
ENDCLUS	DEFW	#FFFF

DIRSPEC	DEFB	"\"
	DEFS	255,0

;GOD	 EQU	 1999-1980*512

;FHAND	 DEFB	 "	  "
;	 DEFB	 "   "
;	 DEFB	 #20
;	 DEFW	 0,0,0,0,0
;	 DEFW	 #0000
;	 DEFW	 5*32+19+GOD
;SAVEC	 DEFW	 #0000
;SIZEC	 DEFW	 #0000,#0000
;=============================================
;//MODULE: DOS_X
;[END]



