;[BEGIN]
;
; SPECTRUM.EXE file.trd
;
	ORG	#8100-512
	INCLUDE	"dos_equ.asm"
	DB	"EXE"	;EXE ID
	DB	#00	;EXE VERSION
	DW	#0200	;CODE OFFSET LOW
	DW	#0000	;CODE OFFSET HIGH
	DW	#0000	;END-BEG ;PRIMARY LOADER
	DW	#0000	;
	DW	#0000	;RESERVED
	DW	#0000	;
	DW	#8100	;LOAD ADDRESS
	DW	#8100	;START ADDRESS
	DW	#BFFF	;STACK ADDRESS
	DS	490

START	PUSH	IX
;	CALL	CRLF
;	CALL	CRLF
	LD	HL,HELLO
	CALL	PRINTZ

	LD	HL,IDBUF
	LD	C,#EF	;GET MODEL ID
	RST	#08
	LD	HL,IDBUF
	XOR	A
	LD	BC,256
	CPIR
	LD	A,(HL)
	OR	A
	JR	Z,SPRINTER97
	LD	DE,SPRINT
	CALL	COMPARE
	JP	Z,SPRINTER2000
	LD	HL,ERRORMESSAGE
	POP	IX
QUIT	CALL	PRINTZ
	LD	C,#41	;EXIT
	RST	#10
	RET

SPRINTER2000
SPRINTER97
	POP	HL
	INC	HL
	LD	DE,IDBUF
	LD	C,#43
	RST	#10
	LD	A,(IDBUF)
	OR	A
	JR	Z,RUNZX
	CP	"-"
	JR	NZ,RUNTRD
	LD	A,(IDBUF+1)
	LD	HL,HELP
	CP	"h"
	JR	Z,QUIT
	CP	"H"
	JR	Z,QUIT
	CP	"?"
	JR	Z,QUIT
	LD	HL,ERRORKEY
	JP	QUIT

RUNTRD	LD	HL,OPENTRD
	CALL	PRINTZ
	LD	HL,IDBUF
	PUSH	HL
	CALL	PRINTZ
	CALL	CRLF
	POP	HL
	CALL	READRAM
	JR	C,SKIP
	LD	A,0
	LD	C,#CB	;SET A: - RAMDISK E:
	LD	B,0
	RST	#08
	LD	A,1
	LD	(TDOS),A
	JP	TO_ZX
SKIP
RUNZX
	LD	C,#CC	;SET A: - FDD
	LD	A,0
	LD	B,0
	RST	#08
	XOR	A
	LD	(TDOS),A
	JP	TO_ZX

TO_ZX	DI 
;	LD	A,#FE
;	OUT	(#E2),A
;	LD	HL,#C100	;set ram disk
;	LD	A,0		;FDD
;	LD	(HL),A
	LD	A,#00
	OUT	(#E2),A
	DI
	LD	HL,GOGOGO
	LD	DE,#C000
	LD	BC,ENDGO-GOGOGO
	LDIR 
	LD	A,(TDOS)
	JP	#C000

TDOS	DB	0

GOGOGO	LD	B,A
	LD	A,0
	OUT	(#82),A
	LD	A,5
	OUT	(#A2),A
	LD	A,2
	OUT	(#C2),A
	LD	A,0
	OUT	(#E2),A

	LD	SP,#BFFF
	PUSH	BC

	XOR	A
	LD	BC,#1FFD
	OUT	(C),A

	LD	A,0
	LD	C,#F2
	CALL	#3D13
	XOR	A
	LD	B,2
	LD	C,#A6
	CALL	#3D13	;RESTORE SPECTRUM PALETTE
	LD	HL,#5104
	LD	BC,#0480
	LD	E,#00
	CALL	#3D13

	LD	C,#EE
	CALL	#3D13

	POP	AF
	LD	HL,0
	PUSH	HL
	OR	A
	JP	NZ,#3D2F
	XOR	A
	LD	BC,#7FFD
	OUT	(C),A
	RET

ENDGO

COMPARE	LD	B,9
COMPAR1	LD	A,(DE)
	CP	(HL)
	INC	HL
	INC	DE
	RET	NZ
	DJNZ	COMPAR1	
	RET

SPRINT	DB	"Sprinter",0

CRLF	LD	A,#0D
	LD      C,PUTCHAR
	RST     #10
	LD      A,#0A
	LD      C,PUTCHAR
	RST     #10
	RET

PRINTZ	LD	A,(HL)
	INC	HL
	OR	A
	RET	Z
	CP	"%"
	JR	NZ,PRINTZ2
	LD	A,(HL)
	INC	HL
	SUB	"1"
	PUSH	HL
	LD	L,A
	LD	H,0
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	BC,PRM1
	ADD	HL,BC
	LD	C,PCHARS
	RST	#10
	POP	HL
	JR	PRINTZ
PRINTZ2	LD	C,PUTCHAR
	RST	#10
	JP	PRINTZ

PRINT_	LD	C,PUTCHAR
	RST	#10
	RET

PRM1    DB      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
PRM2    DB      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
PRM3    DB      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
PRM4    DB      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
PRM5    DB      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
PRM6    DB      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
PRM7    DB      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
PRM8    DB      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
PRM9    DB      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

HELLO	DB	13,10,"SPECTRUM SWITCHER version 1.00",13,10
	DB	"Copyright (c) 2001 PETERS PLUS LTD, All Rights reserved.",13,10
	DB	"Type SPECTRUM -? for help.",13,10,13,10,0

HELP	DB	"Usage: SPECTRUM.EXE [-h][filename.trd]",13,10,13,10

	DB	"filename - Full path to the file with extentension TRD.",13,10
	DB	"<switch>",13,10
	DB	"-h       - Display this help message",13,10
	DB	13,10,0

ERRORKEY
	DB	"Unknown key.",13,10,13,10,0

OPENTRD	DB	"Reading TRD-image file: ",0

ERRORMESSAGE
	DB	13,10
	DB	"You started SPECTRUM.EXE incompatible with this model of computer.",13,10
	DB	"Please, contact with our local-distibutor for update this program",13,10
	DB	"or download it from our web site http://www.petersplus.da.ru/",13,10,13,10,0

PAGE2	EQU	#C2
PAGE3	EQU	#E2

F_HANDLE DB	0

SIZE0	DW	0
SIZE1	DW	0

READRAM
	XOR	A
	LD	C,#11	;OPEN FILE
	RST	#10
	RET	C
	LD	(F_HANDLE),A
	
	LD	HL,0
	LD	IX,0
	LD	A,(F_HANDLE)
	LD	BC,#0215	;MOVE FILE POINTER TO END FILE
	RST	#10
	LD	(SIZE1),HL
	LD	(SIZE0),IX
	CALL	MEM_CLK
	JR	C,CLFIL

	CALL	RDBLK
CLFIL
	LD	A,(F_HANDLE)
	LD	C,#12	;CLOSE FILE
	RST	#10
	RET


MEM_CLK	LD	HL,(SIZE1)
	LD	BC,(SIZE0)
	LD	DE,16384
	XOR	A
	SCF
KBT01	RR	D
	RR	E
	JR	C,KBT02
	RR	H
	RR	L
	RR	B
	RR	C
	JR	NC,KBT01
	LD	A,1
	JR	KBT01
KBT02	OR	A
	JR	Z,KBT03
	INC	BC
KBT03	XOR	A
	CP	B
	SCF
	RET	NZ
	LD	B,C	;SIZE IN BLOCKS 16k
	PUSH	BC
	LD	A,#00
	LD	C,#93
	RST	#08
	POP	BC
	LD	A,#00
	LD	C,#92
	RST	#08
	RET

RDBLK
        LD      HL,0
        LD      IX,0
        LD      A,(F_HANDLE)
        LD      BC,#0015        ;MOVE FILE POINTER TO START FILE
        RST     #10

	LD	A,#00	;RAM DISK NUMBER
	LD	C,#CE	;GET RAM DISK'S ID
	RST	#08
	RET	C
	LD	B,0
	LD	C,#C4	;GET PHISICAL PAGE NUMBER
	RST	#08
	RET	C
BLAGAIN	PUSH	AF
	OUT	(PAGE3),A
	LD	HL,#C000
	LD	DE,#4000
	LD	C,#13	;READ FILE
	LD	A,(F_HANDLE)
	RST	#10
	POP	BC
	RET	C
	CP	#FF
	RET	Z
	LD	A,B
	LD	C,#C7	;GET NEXT PAGE
	RST	#08
	RET	C
	CP	#FF
	JR	NZ,BLAGAIN
	RET

IDBUF	DS	256
