
;[BEGIN]
;//MODULE: EXECUTE
;//CREATE: 19-05-1998	AUTHOR:	Denis Parinov
;//UPDATE: 24-10-1999	DNS	Restore	module
;---------------------------------------------------------------
;Rev	Date	   Name	Description
;---------------------------------------------------------------
;R01	14-05-1999 DNS	DECREASE HEADER	SIZE FOR EXE-FILE
;R02	24-05-1999 DNS	FIX CREATE PSP AND
;			MOVE EXEC STACK
;---------------------------------------------------------------
;ENTRY:	HL - COMMAND LINE
;	DE - SWITCH BUFFER
;EXIT:	BUFFER

GSWITCH	XOR	A
	LD	(DE),A
GSWIT1	LD	A,(HL)
	INC	HL
	CP	" "
	RET	C
	JR	Z,GSWIT1
GSWIT2	LD	(DE),A
	LD	A,(HL)
	INC	HL
	INC	DE
	CP	"!"
	JR	NC,GSWIT2
	CP	" "
	LD	A,0
	LD	(DE),A
	RET 

;RET: HL - ALL MEMORY
;     BC - FREE	MEMORY

FREEMEM	LD	C,#C0
	RST	#08
	RET 

; B - SIZE BLOCK
; RET: A - ID MEMORY BLOCK

GETMEM	LD	C,#C2
	RST	#08
	LD	E,A
	LD	A,30
	RET	C
	LD	D,#00
	LD	HL,MEMTAB
	ADD	HL,DE
	LD	A,(TASK)
	LD	(HL),A
	LD	A,E
	AND	A
	RET 

; A - ID BLOCK

RETMEM	LD	E,A
	LD	D,#00
	LD	HL,MEMTAB
	ADD	HL,DE
	LD	A,(TASK)
	CP	(HL)
	LD	A,31
	SCF 
	RET	NZ
	PUSH	DE
	LD	A,E
	LD	C,#C3
	RST	#08
	POP	DE
	LD	A,31
	RET	C
	LD	HL,MEMTAB
	ADD	HL,DE
	LD	(HL),#00
	XOR	A
	RET 

; A - ID BLOCK
; B - NEW SIZE

SETMEM	LD	E,A
	LD	D,#00
	LD	HL,MEMTAB
	ADD	HL,DE
	LD	A,(TASK)
	CP	(HL)
	LD	A,31
	SCF 
	RET	NZ
	LD	D,B
	PUSH	DE
	LD	A,E
	CALL	SIZEBLK
	POP	DE
	LD	A,31
	RET	C
	LD	A,B
	CP	D
	RET	Z
	JR	C,INCMEM
DECMEM	LD	B,D
	LD	A,E
	LD	C,#9D
	RST	#08
	LD	A,B
	LD	C,#C3
	RST	#08
	XOR	A
	RET 

INCMEM	LD	A,D
	SUB	B
	LD	B,A
	LD	C,E
	PUSH	BC
	LD	C,#C2
	RST	#08
	POP	BC
	LD	B,A
	LD	A,30
	RET	C
	LD	A,C
	LD	C,#9E
	RST	#08
	XOR	A
	RET 

SIZEBLK	LD	B,#FF
	LD	C,A
BLK001	INC	B
	PUSH	BC
	LD	A,C
	LD	C,#C4
	RST	#08
	POP	BC
	JR	NC,BLK001
	OR	A
	SCF 
	RET	Z
	XOR	A
	RET 

LEAVMEM	LD	HL,MEMTAB
	LD	BC,256
LEVMEM	LD	A,(TASK)
	CPIR 
	RET	NZ
	PUSH	HL
	PUSH	BC
	DEC	HL
	AND	A
	LD	DE,MEMTAB
	SBC	HL,DE
	LD	A,L
	CALL	RETMEM
	POP	BC
	POP	HL
	JR	LEVMEM

; B - LOGICAL PAGE
; A - ID BLOCK
; HL - BIT 15&14 WINDOW
; RET: A - PAGE	(WIN)

SETWIN	BIT	7,H
	JR	Z,SETWIN1
	BIT	6,H
	JR	Z,SETWIN2
	JR	SETWIN3

; B - LOGICAL PAGE
; A - ID BLOCK
; RET: A - PAGE	(WIN)

SETWIN1	LD	C,#C4
	EX	DE,HL
	RST	#08
	EX	DE,HL
	RET	C
	LD	C,PAGE1
	IN	B,(C)
	OUT	(C),A
	LD	A,B
	RET 

SETWIN2	LD	C,#C4
	EX	DE,HL
	RST	#08
	EX	DE,HL
	RET	C
	LD	C,PAGE2
	IN	B,(C)
	OUT	(C),A
	LD	A,B
	RET 

SETWIN3	LD	C,#C4
	EX	DE,HL
	RST	#08
	EX	DE,HL
	RET	C
	LD	C,PAGE3
	IN	B,(C)
	OUT	(C),A
	LD	A,B
	RET 

EXEC
	LD	(CMDLINE),HL
	LD	A,#01
	LD	(ACCESS),A
	CALL	GETWORD
	RET	C
	LD	HL,TMPNAME
	LD	DE,MASKARE
	CALL	MASK
	RET	C
	CALL	TST_EXT
	LD	A,3
	RET	C
	LD	HL,TASK
	INC	(HL)
	CALL	OPENEXE
	RET	C
	LD	(EXE_FM),A
	LD	HL,EXEBUFF
	LD	DE,#0080	;!#0200(512)	;R02
	LD	A,(EXE_FM)
	CALL	READ
	JP	C,ERREXE
	LD	IX,EXEBUFF
	LD	HL,(EXEBUFF)
	LD	DE,#5845
	AND	A
	SBC	HL,DE
	LD	A,17
	SCF 
	JP	NZ,ERREXE
	LD	A,(IX+3)
	OR	A
	LD	A,18
	SCF 
	JP	NZ,ERREXE
;	LD	HL,TASK
;	INC	(HL)
	LD	DE,(LOADER)
	LD	A,E
	OR	D
	JP	NZ,PRELOAD
	LD	HL,#0000
	LD	IX,#0000
	LD	B,#02
	LD	A,(EXE_FM)
	CALL	MOVE_FP
	LD	DE,(LD_ADDR)
	LD	A,D
	AND	#3F
	LD	D,A
	ADD	IX,DE
	LD	DE,#0000
	ADC	HL,DE
	LD	A,HX
	SLA	A
	RL	L
	RL	H
	SLA	A
	RL	L
	RL	H
	OR	LX
	JR	Z,NOINK
	INC	HL
NOINK	LD	A,H
	OR	A
	JP	NZ,ERREXE0
	LD	B,L
	CALL	GETMEM
	JP	C,ERREXE0
	LD	(EXE_MEM),A
	EXX 
	POP	DE
	LD	HL,#0000
	ADD	HL,SP
	LD	SP,(EXSTACK)
	PUSH	HL
	PUSH	DE
	IN	A,(PAGE3)
	LD	D,A
	IN	A,(PAGE2)
	LD	E,A
	IN	A,(PAGE1)
	PUSH	DE
	PUSH	AF
	LD	(EXSTACK),SP
	LD	SP,HL
	EXX 
	LD	DE,RAMMAP
	LD	BC,#00C4
	LD	A,(EXE_MEM)
	RST	#08
	LD	(DE),A
	INC	DE
	LD	BC,#01C4
	LD	A,(EXE_MEM)
	RST	#08
	LD	(DE),A
	INC	DE
	LD	BC,#02C4
	LD	A,(EXE_MEM)
	RST	#08
	LD	(DE),A
	INC	DE
	LD	BC,#03C4
	LD	A,(EXE_MEM)
	RST	#08
	LD	(DE),A
	LD	HL,(CMDLINE)
	LD	DE,SECBUF+1
	CALL	SCOPYS
	LD	A,#80
	SUB	B
	LD	(SECBUF),A
	LD	SP,EXEBUFF+510	;R02
	LD	A,#FF
	OUT	(PAGE1),A
	OUT	(PAGE2),A
	OUT	(PAGE3),A
	LD	HL,(LD_ADDR)
	LD	DE,RAMMAP
	LD	A,H
	AND	#C0
	CP	#40
	JR	Z,FR4000
	CP	#80
	JR	Z,FR8000
	CP	#C0
	JR	Z,FRC000
FR4000	LD	A,(DE)
	OUT	(PAGE1),A
	INC	DE
FR8000	LD	A,(DE)
	OUT	(PAGE2),A
	INC	DE
FRC000	LD	A,(DE)
	OUT	(PAGE3),A
	CALL	M_PSP
	LD	HL,(OFFCOD2)
	LD	IX,(OFFCOD1)
	LD	B,#00
	LD	A,(EXE_FM)
	CALL	MOVE_FP
				;R02
	LD	SP,#403F	;R02
				;R02
	LD	DE,(LD_ADDR)
	LD	HL,#0000
	AND	A
	SBC	HL,DE
	EX	DE,HL
	LD	HL,(LD_ADDR)
	LD	A,(EXE_FM)
	CALL	READ
	LD	A,(EXE_FM)
	CALL	CLOSE
	LD	SP,(SP_REG)
	LD	HL,(LD_ADDR)
	LD	DE,#0080
	AND	A
	SBC	HL,DE
	EX	DE,HL
	LD	HX,D
	LD	LX,E
	LD	HL,(PC_REG)
	LD	DE,RETFAR
	PUSH	DE
	PUSH	HL
	RET 
RETFAR	JP	LEAVE

TST_EXT	LD	HL,EXE_EXT
	LD	DE,MASKARE+8
	LD	B,3
	LD	A,(DE)
	CP	#20
	JR	NZ,TSTE1
	LDI 
	LDI 
	LDI 
	XOR	A
	RET 
TSTE1	LD	A,(DE)
	CP	(HL)
	SCF 
	RET	NZ
	INC	HL
	INC	DE
	DJNZ	TSTE1
	XOR	A
	RET 

ERREXE0	LD	A,30
ERREXE	PUSH	AF
	LD	A,(EXE_FM)
	CALL	CLOSE
	LD	HL,TASK
	DEC	(HL)
	POP	AF
	RET 

PRELOAD	EX	DE,HL
	LD	DE,(LD_ADDR)
	LD	A,D
	AND	#3F
	LD	D,A
	ADC	HL,DE
	XOR	A
	SLA	H
	RLA 
	SLA	H
	RLA 
	LD	B,A
	LD	A,H
	OR	L
	JR	Z,NOINK2
	INC	B
NOINK2	CALL	GETMEM
	JP	C,ERREXE0
	LD	(EXE_MEM),A
	EXX 
	POP	DE
	LD	HL,#0000
	ADD	HL,SP
	LD	SP,(EXSTACK)
	PUSH	HL
	PUSH	DE
	IN	A,(PAGE3)
	LD	D,A
	IN	A,(PAGE2)
	LD	E,A
	IN	A,(PAGE1)
	PUSH	DE
	PUSH	AF
	LD	(EXSTACK),SP
	LD	SP,HL
	EXX 
	LD	DE,RAMMAP
	LD	BC,#00C4
	LD	A,(EXE_MEM)
	RST	#08
	LD	(DE),A
	INC	DE
	LD	BC,#01C4
	LD	A,(EXE_MEM)
	RST	#08
	LD	(DE),A
	INC	DE
	LD	BC,#02C4
	LD	A,(EXE_MEM)
	RST	#08
	LD	(DE),A
	INC	DE
	LD	BC,#03C4
	LD	A,(EXE_MEM)
	RST	#08
	LD	(DE),A
	LD	HL,(CMDLINE)
	LD	DE,SECBUF+1
	CALL	SCOPYS
	LD	A,#80
	SUB	B
	LD	(SECBUF),A
	LD	SP,EXEBUFF+510
	LD	A,#FF
	OUT	(PAGE1),A
	OUT	(PAGE2),A
	OUT	(PAGE3),A
	LD	HL,(LD_ADDR)
	LD	DE,RAMMAP
	LD	A,H
	AND	#C0
	CP	#40
	JR	Z,FR4000H
	CP	#80
	JR	Z,FR8000H
	CP	#C0
	JR	Z,FRC000H
FR4000H	LD	A,(DE)
	OUT	(PAGE1),A
	INC	DE
FR8000H	LD	A,(DE)
	OUT	(PAGE2),A
	INC	DE
FRC000H	LD	A,(DE)
	OUT	(PAGE3),A
	CALL	M_PSP
	LD	HL,(OFFCOD2)
	LD	IX,(OFFCOD1)
	LD	B,#00
	LD	A,(EXE_FM)
	CALL	MOVE_FP
				;R02
	LD	SP,#403F	;R02
				;R02
	LD	HL,(LD_ADDR)
	LD	DE,(LOADER)
	LD	A,(EXE_FM)
	CALL	READ
	LD	SP,(SP_REG)
	LD	HL,(LD_ADDR)
	LD	DE,#0080
	AND	A
	SBC	HL,DE
	EX	DE,HL
	LD	HX,D
	LD	LX,E
	LD	HL,(PC_REG)
	LD	DE,RETFAR
	PUSH	DE
	PUSH	HL
	RET 

LEAVE	LD	A,B
	LD	(ERLEVEL),A
	CALL	LEAVMEM
	LD	HL,TASK
	DEC	(HL)
	LD	SP,(EXSTACK)
	POP	AF
	POP	HL
	OUT	(PAGE1),A
	LD	A,L
	OUT	(PAGE2),A
	LD	A,H
	OUT	(PAGE3),A
	POP	DE
	POP	HL
	LD	(EXSTACK),SP
	LD	SP,HL
	EX	DE,HL
	LD	A,(ERLEVEL)
	AND	A
	JP	(HL)

WAIT	LD	A,(ERLEVEL)
	AND	A
	RET 

M_PSP	LD	HL,(LD_ADDR)
	DEC	H
	LD	D,H
	LD	E,L
	INC	DE
	LD	BC,#00FF
	LD	(HL),B
	LDIR 
	EX	DE,HL
	DEC	H
	LD	DE,#0080
	ADD	HL,DE
	EX	DE,HL
	LD	HX,D
	LD	LX,E
	LD	HL,SECBUF
	LD	C,(HL)
	INC	C
	LDIR 
	LD	(HL),B
	LD	A,(TASK)
	LD	(IX-1),A
	LD	A,(EXE_MEM)
	LD	(IX-2),A
	LD	A,(EXE_FM)
	LD	(IX-3),A
	RET 

SCOPYS	LD	BC,#8021
SCOP0	LD	A,(HL)
	CP	C
	JR	C,SCOP1
	INC	HL
	DJNZ	SCOP0
	XOR	A
	LD	(DE),A
	LD	B,#80
	RET 
SCOP1	LD	BC,#8020
SCOP2	LD	A,(HL)
	LD	(DE),A
	INC	HL
	INC	DE
	CP	C
	RET	C
	DJNZ	SCOP2
	RET 

EXE_EXT	DEFB	"EXE"

TASK	DEFB	#01

RAMMAP	DEFB	#00,#00,#00,#00

ERLEVEL	DEFB	#00

EXE_FM	DEFB	#00
EXE_MEM	DEFB	#00

CMDLINE	DEFW	#0000

EXSTACK	DEFW	XSTACK

EXEBUFF
	DEFB	"EXE"
	DEFB	#00
OFFCOD1	DEFW	#0000
OFFCOD2	DEFW	#0000
LOADER	DEFW	#0000
	DEFW	#0000
	DEFW	#0000
	DEFW	#0000
LD_ADDR	DEFW	#0000
PC_REG	DEFW	#0000
SP_REG	DEFW	#0000
	DEFS	$+512-EXEBUFF

	DEFS	255,0
XSTACK	DEFB	#00

;//MODULE: EXECUTE
;[END]



