
;========================================================
R170	EQU	0050H	;Data
R171	EQU	0051H	;Error
R172	EQU	0052H	;Direct
R173	EQU	0053H	;Reserve
R174	EQU	0054H	;Lenght	block low
R175	EQU	0055H	;Lenght	block high
R176	EQU	4052H	;Drive device
R177	EQU	4053H	;Status

W170	EQU	0150H	;Data
W171	EQU	0151H	;????
W172	EQU	0152H	;????
W173	EQU	0153H	;Reserve
W174	EQU	0154H	;Lenght	block low
W175	EQU	0155H	;Lenght	block high
W176	EQU	4152H	;Drive device
W177	EQU	4153H	;Command

BSY	EQU	7
DRQ	EQU	3
ERR	EQU	0

SIZESEC	DEFW	0800H
PKTSIZE	DEFB	12

CD_TEST:
	LD	HL,CMDNOPP
	LD	DE,0
	CALL	AP_COM
	RET 

CD_OPEN:
	LD	HL,CMDOPEN
	LD	DE,0
	CALL	AP_COM
	RET 

CD_CLOS:
	LD	HL,CMDCLOS
	LD	DE,0
	CALL	AP_COM
	RET 

; HL:IX	- SECTOR
;    DE	- ADDRESS
;     A	- DRIVE

CD_READ:
	LD	C,A
	LD	A,H
	LD	(SECREAD+0),A
	LD	A,L
	LD	(SECREAD+1),A
	LD	A,HX
	LD	(SECREAD+2),A
	LD	A,LX
	LD	(SECREAD+3),A
	LD	A,B
	LD	(COUNT+1),A
	LD	HL,CMDREAD
	LD	A,C
	CALL	AP_COM
	RET 

; INPUT:  HL - AP paket	(12bytes)
; RETURN: CF - ERROR
;	 01h - RECOVERED ERROR
;	 02h - NOT READY
;	 03h - MEDIUM ERROR
;	 04h - HARDWARE	ERROR
;	 05h - ILLEGAL REQUEST
;	 06h - UNIT ATTETION
;	 07h - DATA PROTECT
;	 0Bh - ABORTED COMMAND
;	 80h - TIME OUT

AP_COM:
	AND	1
	LD	A,0A0H
	JR	Z,APCOM1
	LD	A,0B0H
APCOM1:	LD	BC,W176
	OUT	(C),A		;SELECT	DRIVE
	EXX 
	LD	DE,8000H
	LD	BC,R177
	CALL	WAITPRT
	EXX 
	JR	NC,CDREADY
	LD	BC,W177
	LD	A,08H
	OUT	(C),A
	LD	B,00H
	DJNZ	$
	EXX 
	LD	DE,8000H
	LD	BC,R177
	CALL	WAITPRT
	EXX 
	RET	C
CDREADY:
	XOR	A
	EXX 
	LD	BC,W171
	OUT	(C),A
	LD	DE,(SIZESEC)	;SIZE BLOCK
	LD	BC,W174
	OUT	(C),E
	LD	BC,W175
	OUT	(C),D
	LD	BC,W177
	LD	A,0A0H
	OUT	(C),A
	LD	DE,8000H
	LD	BC,R177
	CALL	WAITPRT
	EXX 
	RET	C
	EXX 
	LD	DE,0908H
	LD	BC,R177
	CALL	WAITPRT
	EXX 
	BIT	ERR,A
	JR	NZ,CDERROR
	JR	NC,YEP_DRQ
	LD	A,80H
	RET 

YEP_DRQ:
	LD	BC,W170
	LD	A,(PKTSIZE)
	SRL	A
OUTPKT:	OUTI 
	OUTI 
	DEC	A
	JR	NZ,OUTPKT
	LD	B,80H
	DJNZ	$
AP_LOOP:
	EXX 
	LD	DE,8000H
	LD	BC,R177
	CALL	WAITPRT
	EXX 
	RET	C
	LD	BC,R177
	IN	A,(C)
	BIT	ERR,A
	JR	Z,NO_ERR
CDERROR:
	LD	BC,R171	;ERROR
	IN	A,(C)
	RRCA 
	RRCA 
	RRCA 
	RRCA 
	AND	0FH
	SCF 
	RET 

NO_ERR:	BIT	DRQ,A
	LD	A,0
	RET	Z	;NO DATA REQUEST
	EX	DE,HL
	LD	BC,R174
	IN	E,(C)
	LD	BC,R175
	IN	D,(C)	;TRANSFER BLOCK	SIZE
	LD	A,D
	OR	E
	RET	Z	;BLOCK = 0
	LD	BC,R172
	IN	A,(C)
	AND	02H
	CP	02H
	JP	Z,FROM_CD
TO_CD:	LD	BC,R170
WR_T_CD:
	OUTI 
	OUTI 
	DEC	DE
	DEC	DE
	LD	A,D
	OR	E
	JR	NZ,WR_T_CD
	JR	ENDTRAN

FROM_CD:
	LD	A,H
	OR	L
	JR	Z,NULL
	LD	BC,R170
RD_F_CD:
	INI 
	INI 
	DEC	DE
	DEC	DE
	LD	A,D
	OR	E
	JR	NZ,RD_F_CD
ENDTRAN:
	LD	BC,R177
	IN	A,(C)
	AND	A
	BIT	BSY,A
	LD	A,0
	RET	Z
	JP	AP_LOOP

NULL:	LD	BC,R170
RD_N_CD:
	IN	A,(C)
	DEC	B
	IN	A,(C)
	DEC	B
	DEC	DE
	DEC	DE
	LD	A,D
	OR	E
	JR	NZ,RD_N_CD
	JR	ENDTRAN

; D - MASK
; E - PATTERN
; BC - PORT

WAITPRT:
	LD	A,5
	LD	HL,0000H
WAITPX:	EX	AF,AF'
WAITP0:	IN	A,(C)
	CP	0FFH
	JR	Z,WAITP1
	AND	D
	CP	E
	JR	NZ,WAITP2
	AND	A
	RET 

WAITP2:	DEC	L
	JR	NZ,WAITP0
	DEC	H
	JR	NZ,WAITP0
	EX	AF,AF'
	DEC	A
	JR	NZ,WAITPX
	EX	AF,AF'
WAITP1:	SCF 
	RET 

CMDNOPP:
	DEFB	00H
	DEFB	0,0,0
	DEFB	0
	DEFB	0,0,0
	DEFB	0,0,0
	DEFB	0

CMDOPEN:
	DEFB	01BH
	DEFB	0,0,0
	DEFB	2
	DEFB	0,0,0,0,0,0,0

CMDCLOS:
	DEFB	01BH
	DEFB	0,0,0
	DEFB	3
	DEFB	0,0,0,0,0,0,0

CMDREAD:
	DEFB	028H,0
SECREAD:
	DEFB	0,0,0,0
	DEFB	0
COUNT:	DEFB	0,1
	DEFB	0,0,0

;========================================================
BUFFER



