
	ORG	#8000
PAGE1	EQU	#A2
PAGE3	EQU	#E2
SYSPAGE	EQU	#FE

	CALL	INIT_RD
	LD	HL,0
	LD	IX,100
	LD	B,8
	LD	A,0
	LD	DE,#9000
	CALL	READR
	RET 
	RET 
	RET 


; HL:IX	- SECTOR
;    DE	- ADDRESS
;     B	- COUNT
;     A	- DRIVE

READR	PUSH	BC
	PUSH	IX
	PUSH	HL
	PUSH	BC
	CALL	RAMADDR
	POP	BC
	LD	IX,512
RAMRLOP	PUSH	BC
	PUSH	IX
	CALL	LRDSEC
	POP	IX
	POP	BC
	DJNZ	RAMRLOP
	POP	HL
	POP	IX
	POP	BC
	XOR	A
	CP	B
	LD	C,B
	LD	B,A
	JR	Z,DYEP256
	ADD	IX,BC
	LD	C,B
	ADC	HL,BC
	XOR	A
	RET 

DYEP256	INC	B
	ADD	IX,BC
	LD	B,C
	ADC	HL,BC
	XOR	A
	RET 


; HL:IX	- SECTOR
;    DE	- ADDRESS
;     B	- COUNT
;     A	- DRIVE

WRITER	PUSH	BC
	PUSH	IX
	PUSH	HL
	PUSH	BC
	CALL	RAMADDR
	POP	BC
	LD	IX,512
RAMWLOP	PUSH	BC
	PUSH	IX
	CALL	WRDSEC
	POP	IX
	POP	BC
	DJNZ	RAMWLOP
	POP	HL
	POP	IX
	POP	BC
	XOR	A
	CP	B
	LD	C,B
	LD	B,A
	JR	Z,WYEP256
	ADD	IX,BC
	LD	C,B
	ADC	HL,BC
	XOR	A
	RET 

WYEP256	INC	B
	ADD	IX,BC
	LD	B,C
	ADC	HL,BC
	XOR	A
	RET 

INIT_RD

	LD	HL,512
	LD	A,#80
INIT_R1	SRL	A
	RR	H
	JR	NC,INIT_R1
	LD	(S_P_P),A


	LD	BC,#00CE   ;TYPE RAM DISK
	LD	DE,RAMDTBL
INIT_R0	PUSH	BC
	LD	A,B
	CALL	#3D13
	OR	A
	JR	Z,NORAMD
	LD	(DE),A
	INC	DE
NORAMD	POP	BC
	INC	B
	LD	A,#10
	CP	B
	JR	NZ,INIT_R0
	LD	HL,RAMDTBL
	EX	DE,HL
	AND	A
	SBC	HL,DE
	LD	A,L
	LD	IX,ENDDRVR
	AND	A
	RET 


RAMDTBL	DEFB	#FF,#FF,#FF,#FF
	DEFB	#FF,#FF,#FF,#FF
	DEFB	#FF,#FF,#FF,#FF
	DEFB	#FF,#FF,#FF,#FF

; SECTOR / S_P_P = START PAGE
; INPUT	: HL:IX	-SECTOR
; OUTPUT: A':HL	- ADDRESS

RAMADDR	LD	BC,RAMDTBL
	ADD	A,C
	LD	C,A
	LD	A,0
	ADC	A,B
	LD	B,A
	LD	A,(BC)
	EX	AF,AF'
	LD	B,HX
	LD	C,LX
	LD	A,(S_P_P)	;   (S_P_P)	  ;SECTORS PER P
;AGE
DIVR0	RRCA 
	JR	C,DIVR1
	RR	H
	RR	L
	RR	B
	RR	C
	JR	DIVR0
DIVR1	LD	B,C
	LD	C,#C4	;GET FIRST PAGE
	EX	AF,AF'
	CALL	#3D13
	EX	AF,AF'
	LD	A,(S_P_P)
	LD	C,A
	DEC	C
	LD	A,LX
	AND	C
	INC	A
	LD	HL,#C000
	LD	BC,512
	SBC	HL,BC
ADDLP	ADD	HL,BC
	DEC	A
	JR	NZ,ADDLP
	RET 

S_P_P	DEFB	#00

; A':HL	- ADDRESS SOURCE
;    DE	- ADDRESS DESTINATION

LRDSEC	LD	A,D
	CP	#A0
	LD	C,PAGE3
	SET	6,H
	JR	C,RMDL02
	LD	C,PAGE1
	RES	7,H
RMDL02	IN	A,(C)
	EX	AF,AF'
	OUT	(C),A
	LD	B,HX
	LD	HX,C
	LD	C,LX
	LDIR 
	EX	AF,AF'
	LD	C,HX
	OUT	(C),A
	LD	A,H
	AND	#7F
	RET	NZ
	LD	C,PAGE3		;GET NEXT PAGE
	IN	B,(C)
	LD	A,SYSPAGE
	OUT	(C),A
	EX	AF,AF'
	LD	HX,#C2
	LD	LX,A
	LD	A,(IX)
	EX	AF,AF'
	OUT	(C),B
	LD	H,#C0
	RET 

; A':HL	- ADDRESS SOURCE
;    DE	- ADDRESS DESTINATION

WRDSEC	LD	A,D
	CP	#A0
	LD	C,PAGE3
	SET	6,H
	JR	C,WMDL02
	LD	C,PAGE1
	RES	7,H
WMDL02	IN	A,(C)
	EX	AF,AF'
	OUT	(C),A
	LD	B,HX
	LD	HX,C
	LD	C,LX
	EX	DE,HL
	LDIR 
	EX	DE,HL
	EX	AF,AF'
	LD	C,HX
	OUT	(C),A
	LD	A,H
	AND	#7F
	RET	NZ
	LD	C,PAGE3		;GET NEXT PAGE
	IN	B,(C)
	LD	A,SYSPAGE
	OUT	(C),A
	EX	AF,AF'
	LD	HX,#C2
	LD	LX,A
	LD	A,(IX)
	EX	AF,AF'
	OUT	(C),B
	LD	H,#C0
	RET 

ENDDRVR



