
;[BEGIN]
;//MODULE: VIDEO
;//CREATE: 19-05-1998	AUTHOR:	Denis Parinov
;//UPDATE: 24-10-1999	DNS	Restore	module

CLEAR	LD	C,#8D
	RST	#08
	AND	A
	RET 

PCHARS	LD	A,(HL)
	INC	HL
	OR	A
	RET	Z
	PUSH	HL
	CALL	PUTCHAR
	POP	HL
	JP	PCHARS

PUTCHAR	CP	#20
	JP	NC,CHAR
	CP	#0D
	JP	Z,CR_
	CP	#0A
	JP	Z,LF_
	CP	#09
	JP	Z,TB_
	CP	#08
	JP	Z,BK_
CHAR	PUSH	HL
	LD	BC,#0182
	RST	#08
	POP	HL
	RET 

BK_	LD	C,#8E	;GET CURSOR
	RST	#08
	XOR	A
	CP	E
	JP	Z,LOCATE
	DEC	E
	JP	LOCATE

TB_	LD	C,#8E	;GET CURSOR
	RST	#08
	LD	B,E
	LD	A,E
	AND	#F8
	ADD	A,8
	SUB	B
	LD	B,A
	LD	C,#82
	LD	A,#20
	RST	#08
	RET 

CR_	LD	C,#8E	;GET CURSOR
	RST	#08
	LD	E,0
	JP	LOCATE

LF_	LD	C,#8E	;GET CURSOR
	RST	#08
	LD	A,D
	CP	#1F
	JP	Z,LFF
	INC	D
	JP	LOCATE

LFF	PUSH	HL
	PUSH	DE
	LD	BC,#018A
	LD	DE,#0020
	EI 
	HALT 
	DI 
	RST	#08
	LD	DE,#1F00
	CALL	LOCATE
	LD	A,#20
	LD	BC,#5082
	RST	#08
	EI 
	POP	DE
	CALL	LOCATE
	POP	HL
	RET 

LOCATE	LD	C,#84
	RST	#08
	RET 

CURSOR	LD	C,#8E
	RST	#08
	RET 

RDCHAR	XOR	A
	LD	C,#B4
	RST	#08
	LD	A,L
	LD	B,H
	AND	A
	RET 

WRCHAR	LD	C,A
	PUSH	BC
	PUSH	DE
	LD	C,#B4
	XOR	A
	RST	#08
	POP	DE
	POP	HL
	LD	C,#B5
	XOR	A
	RST	#08
	AND	A
	RET 

WINCOPY	XOR	A
	LD	C,#B2
	RST	#08
	AND	A
	RET 

WINREST	XOR	A
	LD	C,#B3
	RST	#08
	AND	A
	RET 

SCROLL	DJNZ	SCR_DW
	LD	B,A
	LD	C,H
	PUSH	BC
	PUSH	DE
	PUSH	HL
	LD	HX,D
	LD	LX,E
	INC	D
	DEC	H
	LD	C,#B7
	XOR	A
	RST	#08
	POP	HL
	POP	DE
	POP	BC
	XOR	A
	CP	B
	RET	NZ
	LD	A,D
	ADD	A,H
	LD	D,A
	CALL	LOCATE
	LD	A,#20
	LD	B,L
	LD	C,#82
	RST	#08
	AND	A
	RET 

SCR_DW	DJNZ	SCR_ERR
	LD	B,A
	LD	C,L
	PUSH	DE
	PUSH	BC
	LD	HX,D
	LD	LX,E
	INC	HX
	DEC	H
	LD	C,#B7
	XOR	A
	RST	#08
	POP	HL
	POP	DE
	XOR	A
	CP	B
	RET	NZ
	CALL	LOCATE
	LD	A,#20
	LD	B,L
	LD	C,#82
	RST	#08
	AND	A
	RET 

SCR_ERR	LD	A,1
	SCF 
	RET 

SELPAGE	PUSH	BC
	LD	A,(VMODE)
	BIT	7,A
	JR	NZ,SEL2
	LD	C,A
	CALL	TEXT_M
SEL2	POP	BC
	LD	A,B
	AND	#01
	OUT	(#C9),A
	RET 

GETVMOD	IN	A,(#C9)
	LD	B,A
	LD	A,(VMODE)
	AND	A
	RET 

SETVMOD	BIT	7,A
	LD	C,A
	JR	NZ,GRAPH
TEXT_M	LD	IX,BACKTXT
	PUSH	IX
	EX	AF,AF'
	LD	A,(VMODE)
	LD	(VVMODE),A
	EX	AF,AF'
	INC	A
	DEC	A
	JR	Z,NOMODE
	DEC	A
	JR	Z,NOMODE
	DEC	A
	JP	Z,T_40_32
	DEC	A
	JP	Z,T_80_32
NOMODE	POP	IX
	LD	A,#30
	SCF 
	RET 

GRAPH	CALL	SAVETXT
	AND	#7F
	JP	Z,G320_16
	DEC	A
	JP	Z,G320_56
	DEC	A
	JP	Z,G640_16
	DEC	A
	JP	Z,G640_56
	LD	A,#30
	SCF 
	RET 

T_40_32	PUSH	BC
	LD	HL,TAB2
	LD	A,B
	RLCA 
	RLCA 
	RLCA 
	RLCA 
	OR	B
	AND	#11
	XOR	#10
	LD	E,A
	CALL	SETMODE
	POP	BC
	LD	A,C
	LD	(VMODE),A
	LD	A,B
	AND	#01
	OUT	(#C9),A
	LD	A,(VMODE)
	LD	C,#81
	RST	#30
	LD	A,#C0
	OUT	(Y_PORT),A
	XOR	A
	RET 

T_80_32	PUSH	BC
	LD	HL,TAB1
	LD	A,B
	RLCA 
	RLCA 
	RLCA 
	RLCA 
	OR	B
	AND	#11
	XOR	#10
	LD	E,A
	CALL	SETMODE
	POP	BC
	LD	A,C
	LD	(VMODE),A
	LD	A,B
	AND	#01
	OUT	(#C9),A
	LD	A,(VMODE)
	LD	C,#81
	RST	#30
	LD	A,#C0
	OUT	(Y_PORT),A
	XOR	A
	RET 

G320_16	LD	A,#30
	SCF 
	RET 

G320_56	PUSH	BC
	LD	HL,TAB4
	LD	E,#11
	CALL	SETMODE
	LD	HL,TAB8
	LD	E,#00
	CALL	SETMODE
	POP	BC
	LD	A,C
	LD	(VMODE),A
	LD	A,B
	AND	#01
	OUT	(#C9),A
	LD	A,(VMODE)
	LD	C,#81
	RST	#30
	LD	A,#C0
	OUT	(Y_PORT),A
	XOR	A
	RET 

G640_16	PUSH	BC
	LD	HL,TAB3
	LD	E,#11
	CALL	SETMODE
	LD	HL,TAB7
	LD	E,#00
	CALL	SETMODE
	POP	BC
	LD	A,C
	LD	(VMODE),A
	LD	A,B
	AND	#01
	OUT	(#C9),A
	LD	A,(VMODE)
	LD	C,#81
	RST	#30
	LD	A,#C0
	OUT	(Y_PORT),A
	XOR	A
	RET 

G640_56	LD	A,#30
	SCF 
	RET 

VMODE	DEFB	#03

;02h - TEXT 40 x 32 (16	colors)
;03h - TEXT 80 x 32 (16	colors)
;80h - GRAF 320	x 256 (16 colors)
;81h - GRAF 320	x 256 (256 colors)
;82h - GRAF 640	x 256 (16 colors)
;83h - GRAF 640	x 256 (256 colors) UNUSED

SETMODE	PUSH	DE
	LD	DE,#FEE0
	LD	BC,#0020
	CALL	MOVBIOS
	POP	DE
	LD	IX,#FEE0
	LD	HL,#0000
	LD	C,#B0
	RST	#08
	LD	A,#C0
	OUT	(Y_PORT),A
	XOR	A
	RET 

MOVBIOS	LD	A,R
	IN	A,(PAGE3)
	EX	AF,AF'
	LD	A,#FE
	OUT	(PAGE3),A
	LDIR 
	EX	AF,AF'
	OUT	(PAGE3),A
	RET	PO
	EI 
	RET 

;IX+0	;HORIZONTAL
;IX+1	;VERTICAL
;IX+2	;X - COORD
;IX+3	;Y - COORD
;IX+4	;MODE
;IX+5	;EXT MODE
;IX+6	;VIDEO RAM X OFFSET (SIGNPLACES)
;IX+7	;VIDEO RAM Y OFFSET (SIGNPLACES)

;80x32
TAB1	DEFB	#28,#20,#00,#00,#1B,#00,#00,#00
;40x32
TAB2	DEFB	#28,#20,#00,#00,#3B,#00,#00,#00
;640x256 PAGE 0
TAB3	DEFB	#28,#20,#00,#00,#00,#00,#00,#00
;320x256 PAGE 0
TAB4	DEFB	#28,#20,#00,#00,#20,#00,#00,#00
;640x256 PAGE 1
TAB7	DEFB	#28,#20,#00,#00,#40,#00,#28,#00
;320x256 PAGE 1
TAB8	DEFB	#28,#20,#00,#00,#60,#00,#28,#00

SAVETXT	PUSH	AF
	PUSH	BC
	PUSH	DE
	PUSH	HL
	PUSH	IX
	LD	A,(VMODE)
	BIT	7,A
	JR	NZ,NOSAVET
	SUB	#02
	JR	C,NOSAVET
	PUSH	AF
	LD	C,#8E
	RST	#08
	LD	(TCURS),DE
	POP	AF
	LD	IX,#C000
	LD	HL,#2050
	OR	A
	JR	NZ,SVTEXT1
	LD	HL,#2028
SVTEXT1	LD	(SVHL1),HL
	LD	DE,#0000
	LD	A,(BANKTBL+TXTPAGE)
	LD	B,A
	LD	C,#B2
	XOR	A
	DI 
	RST	#08
	EI 
NOSAVET	POP	IX
	POP	HL
	POP	DE
	POP	BC
	POP	AF
	RET 

BACKTXT	PUSH	AF
	PUSH	BC
	PUSH	DE
	PUSH	HL
	PUSH	IX
VVMODE	EQU	$+1
	LD	A,#00
	BIT	7,A
	JR	Z,NOBACKT
	LD	IX,#C000
SVHL1	EQU	$+1
	LD	HL,#2050
	LD	DE,#0000
	LD	A,(BANKTBL+TXTPAGE)
	LD	B,A
	LD	C,#B3
	XOR	A
	DI 
	RST	#08
	EI 
TCURS	EQU	$+1
	LD	DE,#0000
	LD	C,#84
	RST	#08
NOBACKT	POP	IX
	POP	HL
	POP	DE
	POP	BC
	POP	AF
	RET 

LPT_A	EQU	#1B
LPT_B	EQU	#1C

PRINT	LD	B,A
	LD	A,R
	LD	A,B
	DI 
	PUSH	AF
	XOR	A
	OUT	(LPT_A),A
	LD	A,#10
	OUT	(LPT_A),A
	XOR	A
	OUT	(LPT_A),A
	IN	A,(LPT_A)
	BIT	5,A
	JR	Z,LPTBUSY
	LD	A,B
	OUT	(LPT_B),A
	LD	A,5
	OUT	(LPT_A),A
	LD	A,#E2
	OUT	(LPT_A),A
	LD	A,5
	OUT	(LPT_A),A
	LD	A,#E0
	OUT	(LPT_A),A
	POP	AF
	SCF 
	CCF 
	RET	PO
	EI 
	RET 

LPTBUSY	POP	AF
	SCF 
	RET	PO
	EI 
	RET 

;//MODULE: VIDEO
;[END]



