
;========================================================
;55H READH   LOAD SECTORS
;56H WRITEH  SAVE SECTORS
;57H VERIFYH VERIFY SECTORS

Y_PORT	EQU	089H
;Write
HDW_COM	EQU	4153H	;1F7H Command
HDW_DRV	EQU	4152H	;1F6H Drive Control

HDW_CLH	EQU	0155H	;1F5H Cylinder High
HDW_CLL	EQU	0154H	;1F4H Cylinder Low
HDW_SEC	EQU	0153H	;1F3H Sector
HDW_CNT	EQU	0152H	;1F2H Counter
HDW_ERR	EQU	0151H	;1F1H Error
HDW_DAT	EQU	0150H	;1F0H Data
;Read
HDR_CTL	EQU	4053H	;1F7H Status (Control)
HDR_DRV	EQU	4052H	;1F6H Drive Control

HDR_CLH	EQU	0055H	;1F5H Cylinder High
HDR_CLL	EQU	0054H	;1F4H Cylinder Low
HDR_SEC	EQU	0053H	;1F3H Sector
HDR_CNT	EQU	0052H	;1F2H Counter
HDR_ERR	EQU	0051H	;1F1H Error
HDR_DAT	EQU	0050H	;1F0H Data

BSY	EQU	7
RDY	EQU	6
DRQ	EQU	3
ERR	EQU	0

;EQU FOR IY+
DRVHD_H	EQU	0
SC_PT_H	EQU	1
HEADS_H	EQU	2
CYL_L_H	EQU	3
CYL_H_H	EQU	4
SPCLL_H	EQU	5
SPCLH_H	EQU	6

IDE0	EQU	0C1C0H
IDE1	EQU	0C1C8H

;IDE0	 DEFB	 #FF	 ;DRIVE/HEAD REGISTER	      ;00
;	 DEFB	 #FF	 ;SECTORS PER TRACK	      ;01
;	 DEFB	 #FF	 ;HEADS			      ;02
;	 DEFB	 #FF	 ;CYLINDERS LOW		      ;03
;	 DEFB	 #FF	 ;CYLINDERS HIGH	      ;04
;	 DEFB	 #FF	 ;SECTOR PER CYLINDER LOW     ;05
;	 DEFB	 #FF	 ;SECTOR PER CYLINDER HIGH    ;06
;	 DEFB	 #FF	 ;RESERVED		      ;07

;IDE1	 DEFB	 #FF	 ;DRIVE/HEAD REGISTER	      ;00
;	 DEFB	 #FF	 ;SECTORS PER TRACK	      ;01
;	 DEFB	 #FF	 ;HEADS			      ;02
;	 DEFB	 #FF	 ;CYLINDERS LOW		      ;03
;	 DEFB	 #FF	 ;CYLINDERS HIGH	      ;04
;	 DEFB	 #FF	 ;SECTOR PER CYLINDER LOW     ;05
;	 DEFB	 #FF	 ;SECTOR PER CYLINDER HIGH    ;06
;	 DEFB	 #FF	 ;RESERVED		      ;07

;HL:IX - SECTOR
;   DE - ADDRESS
;    B - SECTORS

;READ SECTOR(S)
READH:	PUSH	IY
	EXX 
	LD	C,Y_PORT
	IN	B,(C)
	PUSH	BC
	LD	E,0C0H
	OUT	(C),E
	EXX 
	CALL	RDS000
	EXX 
	POP	BC
	OUT	(C),B
	EXX 
	POP	IY
	RET	NC
	LD	A,4	;NOT READY
	RET 

;READ SECTOR(S)
RDS000:	AND	1
	LD	IY,IDE0
	JR	Z,RDS001
	LD	IY,IDE1
RDS001:	EXX 
	LD	DE,0C040H
	LD	BC,HDR_CTL
	CALL	WAITPRT
	EXX 
	RET	C
	PUSH	DE
	CALL	PRESET
	POP	HL
	LD	BC,HDW_COM
	LD	A,020H		;READ WITH RETRY
	OUT	(C),A
;SAVE HL!
RDS002:	EXX 
	LD	DE,08908H   ;WAIT BUSY=0 & DRQ=1 & ERR=0
	LD	BC,HDR_CTL
	CALL	WAITPRT
	EXX 
	RET	C
	LD	BC,HDR_DAT
	INIR 
	INIR 
;
	LD	A,H
	OR	L
	JR	NZ,W44
	LD	HL,0C000H
W44
;
	LD	BC,HDR_CTL
	IN	A,(C)
	BIT	DRQ,A
	JR	NZ,RDS002
	XOR	A
	RET 

;HL:IX - SECTOR
;   DE - ADDRESS
;    B - SECTORS

;WRITE SECTOR(S)
WRITEH:	PUSH	IY
	EXX 
	LD	C,Y_PORT
	IN	B,(C)
	PUSH	BC
	LD	E,0C0H
	OUT	(C),E
	EXX 
	CALL	WRS000
	EXX 
	POP	BC
	OUT	(C),B
	EXX 
	POP	IY
	RET	NC
	LD	A,4	;NOT READY
	RET 

;WRITE SECTOR(S)
WRS000:	AND	1
	LD	IY,IDE0
	JR	Z,WRS001
	LD	IY,IDE1
WRS001:	EXX 
	LD	DE,0C040H
	LD	BC,HDR_CTL
	CALL	WAITPRT
	EXX 
	RET	C
	PUSH	DE
	CALL	PRESET
	POP	HL
	LD	BC,HDW_COM
	LD	A,030H		;WRITE WITH RETRY
	OUT	(C),A
;SAVE HL!
WRS002:	EXX 
	LD	DE,08908H   ;WAIT BUSY=0 & DRQ=1 & ERR=0
	LD	BC,HDR_CTL
	CALL	WAITPRT
	EXX 
	RET	C
	LD	BC,HDW_DAT
	OTIR 
	OTIR 
;
	LD	A,H
	OR	L
	JR	NZ,W33
	LD	HL,0C000H
W33:
;
	LD	BC,HDR_CTL
	IN	A,(C)
	BIT	DRQ,A
	JR	NZ,WRS002
	XOR	A
	RET 

;HL:IX - SECTOR
;    B - SECTORS

;VERIFY	SECTOR(S)
VERIFYH:
	PUSH	IY
	EXX 
	LD	C,Y_PORT
	IN	B,(C)
	PUSH	BC
	LD	E,0C0H
	OUT	(C),E
	EXX 
	CALL	VRS000
	EXX 
	POP	BC
	OUT	(C),B
	EXX 
	POP	IY
	RET	NC
	LD	A,4	;NOT READY
	RET 

;VERIFY	SECTOR(S)
VRS000:	AND	1
	LD	IY,IDE0
	JR	Z,VRS001
	LD	IY,IDE1
VRS001:	EXX 
	LD	DE,0C040H
	LD	BC,HDR_CTL
	CALL	WAITPRT
	EXX 
	RET	C
	PUSH	DE
	CALL	PRESET
	POP	HL
	LD	BC,HDW_COM
	LD	A,040H		;VERIFY	WITH RETRY
	OUT	(C),A
VRS002:	LD	BC,HDR_CTL
	IN	A,(C)
	BIT	ERR,A
	JR	Z,VRS003
	SCF 
	RET 
VRS003:	LD	DE,08100H   ;WAIT BUSY=0 & ERR=0
	LD	BC,HDR_CTL
	CALL	WAITPRT
	RET	C
	XOR	A
	RET 

; HL:IX	- LBA SECTOR
;     B	- SECTOR COUNTER

PRESET:	LD	A,B
	LD	BC,HDW_CNT
	OUT	(C),A
	IN	A,(0E2H)
	EX	AF,AF'
	LD	A,0FEH
	OUT	(0E2H),A
	LD	A,(IY+DRVHD_H)
	LD	BC,HDW_DRV
	OUT	(C),A
	BIT	6,A
	LD	E,LX
	LD	D,HX
	CALL	Z,LBA_CHS
	LD	BC,HDW_SEC
	OUT	(C),E		;LBA 0..7
	LD	BC,HDW_CLL
	OUT	(C),D		;LBA 8..15
	LD	BC,HDW_CLH
	OUT	(C),L		;LBA 16..23
	LD	BC,HDW_DRV
	DEC	B
	IN	A,(C)
	AND	0F0H
	OR	H		;LBA 24..27
	INC	B
	OUT	(C),A
	EX	AF,AF'
	OUT	(0E2H),A
	AND	A
	RET 

; HL:DE	- SECTOR OFFSET

LBA_CHS:
	LD	C,(IY+SPCLL_H)
	LD	B,(IY+SPCLH_H)
;	HL:DE /	BC => DE:IX HL-OSTATOK
DIV32X:	LD	HX,D
	LD	LX,E
	EX	DE,HL
	LD	HL,0
	LD	A,020H
DIV011:	ADD	IX,IX
	EX	DE,HL
	ADC	HL,HL
	EX	DE,HL
	ADC	HL,HL
	SBC	HL,BC
	JR	NC,DIV012
	ADD	HL,BC
	DEC	A
	JR	NZ,DIV011
	JR	DIV014
DIV012:	INC	IX
	DEC	A
	JR	NZ,DIV011
DIV014:	LD	E,(IY+SC_PT_H)
	LD	D,0
	XOR	A
CHS005:	INC	A
	SBC	HL,DE
	JR	NC,CHS005
	ADD	HL,DE
	DEC	A
	LD	H,A
	LD	E,L
	INC	E
	LD	D,LX
	LD	A,HX
	LD	L,A
	RET 

; D - MASK
; E - PATTERN
; BC - PORT

WAITPRT:
	LD	HL,0000H
WAITP0:	IN	A,(C)
	CP	0FFH
	JR	Z,WAITP1
	AND	D
	CP	E
	JR	NZ,WAITP2
	AND	A
	RET 

WAITP2:	DEC	HL
	LD	A,L
	OR	H
	JP	NZ,WAITP0
WAITP1:	SCF 
	RET 

;=======================================================



